#property copyright "Idea by Nylo, code by Daniil"

#define MAGICMA  20110130
#include <stdlib.mqh>

extern double	Lots = 0.1;
extern int		fSEMA = 1;
extern int		sSEMA = 2;
extern int		fBEMA = 5;
extern int		sBEMA = 15;
extern int		ATR = 96;
extern int		BB_period = 20;
extern int		BB_deviation = 2;
extern int     RSI_period = 14;
extern int     RSI_levelup = 80;
extern int     RSI_leveldown = 20;
extern double	tp_mult = 0.5;
extern double	sl_mult = 2.0;
extern double	bb_mult = 2.0;
extern double	bar_range_mult = 2.0;

int cross_BigEMA = 0;
double fSEMA_curr;
double fSEMA_prev;
double sSEMA_curr;
double sSEMA_prev;
double fBEMA_curr;
double fBEMA_prev;
double sBEMA_curr;
double sBEMA_prev;
double ATR_curr;
double BB_upper, BB_lower;
double RSI;
double Bar_range;

void PrepareAll()
{
    if (Volume[0] > 1)
    	return;

	fSEMA_curr = iMA(NULL, 0, fSEMA, 0, MODE_EMA, PRICE_CLOSE, 1);
	fSEMA_prev = iMA(NULL, 0, fSEMA, 0, MODE_EMA, PRICE_CLOSE, 2);
	sSEMA_curr = iMA(NULL, 0, sSEMA, 0, MODE_EMA, PRICE_CLOSE, 1);
	sSEMA_prev = iMA(NULL, 0, sSEMA, 0, MODE_EMA, PRICE_CLOSE, 2);
	fBEMA_curr = iMA(NULL, 0, fBEMA, 0, MODE_EMA, PRICE_CLOSE, 1);
	fBEMA_prev = iMA(NULL, 0, fBEMA, 0, MODE_EMA, PRICE_CLOSE, 2);
	sBEMA_curr = iMA(NULL, 0, sBEMA, 0, MODE_EMA, PRICE_CLOSE, 1);
	sBEMA_prev = iMA(NULL, 0, sBEMA, 0, MODE_EMA, PRICE_CLOSE, 2);
	ATR_curr   = iATR(NULL, 0, ATR, 1);
	BB_upper   = iBands(NULL, 0, BB_period, BB_deviation, 0, PRICE_CLOSE, MODE_UPPER, 1);
	BB_lower   = iBands(NULL, 0, BB_period, BB_deviation, 0, PRICE_CLOSE, MODE_LOWER, 1);
	RSI        = iRSI(NULL, 0, RSI_period, PRICE_CLOSE, 1);
	Bar_range  = MathAbs(iOpen(NULL, 0, 1) - iClose(NULL, 0, 1));

	if (fBEMA_prev < sBEMA_prev && fBEMA_curr > sBEMA_curr)
	{
		cross_BigEMA = 1;
	} else if (fBEMA_prev > sBEMA_prev && fBEMA_curr < sBEMA_curr)
	{
		cross_BigEMA = -1;
	}
}

int start()
{
	if (Bars < 100 || IsTradeAllowed() == false)
		return;

	PrepareAll();

	if (CalculateCurrentOrders(Symbol()) == 0)
		CheckForOpen();

	return(0);
}

int CalculateCurrentOrders(string symbol)
{
	int buys = 0, sells = 0;

	for (int i = 0; i < OrdersTotal(); i++)
	{
		if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES) == false)
			break;
		if (OrderSymbol() == Symbol() && OrderMagicNumber() == MAGICMA)
		{
			if (OrderType() == OP_BUY)
				buys++;
			if (OrderType() == OP_SELL)
				sells++;
		}
	}

	if (buys > 0)
		return(buys);
	else
		return(-sells);
}

void CheckForOpen()
{
	int res;

    if (Volume[0] > 1)
    	return;

	if (cross_BigEMA == 1 &&
		fSEMA_prev < sSEMA_prev &&
		fSEMA_curr > sSEMA_curr &&
		BB_upper-BB_lower > ATR_curr*bb_mult &&
		RSI < RSI_levelup &&
		Bar_range < ATR_curr*bar_range_mult)
	{
		res = OrderSend(Symbol(), OP_BUY, Lots, Ask, 3, Ask-sl_mult*ATR_curr, Ask+tp_mult*ATR_curr, "", MAGICMA, 0, Blue);
		if (res == -1)
			Print("Buy error: ", ErrorDescription(GetLastError()));
		return;
	} else if (cross_BigEMA == -1 &&
		fSEMA_prev > sSEMA_prev &&
		fSEMA_curr < sSEMA_curr &&
		BB_upper-BB_lower > ATR_curr*bb_mult &&
		RSI > RSI_leveldown &&
		Bar_range < ATR_curr*bar_range_mult)
	{
		res = OrderSend(Symbol(), OP_SELL, Lots, Bid, 3, Bid+sl_mult*ATR_curr, Bid-tp_mult*ATR_curr, "", MAGICMA, 0, Red);
		if (res == -1)
			Print("Sell error: ", ErrorDescription(GetLastError()));
      return;
	}
}